
#DATA
    word monthNameLong janL, febL, marL, aprL, mayL, junL, julL, augL, septL, octL, novL, decL
    byte janL  "JANUARY\0"
    byte febL  "FEBRUARY\0"
    byte marL  "MARCH\0"
    byte aprL  "APRIL\0"
    byte mayL  "MAY\0"
    byte junL  "JUNE\0"
    byte julL  "JULY\0"
    byte augL  "AUGUST\0"
    byte septL "SEPTEMBER\0"
    byte octL  "OCTOBER\0"
    byte novL  "NOVEMBER\0"
    byte decL  "DECEMBER\0"
#END


#CONST
    PDssMonth           // 5 words to store month substring
    PDssDay      5      // 2 words to store day substring
    PDssYear     7      // 3 words to store year substring
    PDptrSsMonth 10     // 1 word  to be used as a byte-aligned pointer to month substring
    PDptrSsDay          // 1 word  to be used as a byte-aligned pointer to day substring
    PDptrSsYear         // 1 word  to be used as a byte-aligned pointer to year substring
    PDptrGDate          // 1 word  to be used as a word-aligned pointer to global date string
    PDptrGMonth         // 1 word  to be used as a word-aligned pointer to global month variable
    PDptrGDay           // 1 word  to be used as a word-aligned pointer to global day variable
    PDptrGYear          // 1 word  to be used as a word-aligned pointer to global year variable
    PDnComma            // 1 word  to be used for storing the index location of the 1st comma character
    PDnSpace            // 1 word  to be used for storing the index location of the 1st space character
    PDlengthFull        // 1 word  to store the full length of the global date string
    PDlengthMonth       // 1 word  to store the length of the month substring
    PDlengthDay         // 1 word  to store the length of the day substring
    PDlengthYear        // 1 word  to store the length of the year substring
    PDptr               // 1 word  to be used as a multi-purpose byte-aligned pointer
    PDcounter           // 1 word  to be used as a multi-purpose counter variable
    PDflag              // 1 word  to be used as a multi-purpose flag variable
#END

var PDClass[PDflag + 1];


func parseDate(var *stringDate, var *globaMonth, var *globalDay, var *globalYear)

    PDClass[PDptrGDate]  := stringDate;
    PDClass[PDptrGMonth] := globaMonth;
    PDClass[PDptrGDay]   := globalDay;
    PDClass[PDptrGYear]  := globalYear;

    PDClass[PDflag] := FALSE;


    PDClass[PDptr] := str_Ptr(PDClass[PDptrGDate]);

    PDClass[PDlengthFull]  := str_Length(PDClass[PDptr]);
    PDClass[PDnComma] := str_FindI(&PDClass[PDptr], ",");
    PDClass[PDnSpace] := str_FindI(&PDClass[PDptr], " ");

    PDClass[PDlengthMonth] := PDClass[PDnSpace] - PDClass[PDptr];
    PDClass[PDlengthDay]   := PDClass[PDnComma] - PDClass[PDnSpace] - 1;
    PDClass[PDlengthYear]  := PDClass[PDptr] + PDClass[PDlengthFull] - PDClass[PDnComma] - 2;



    // a few routines to check if the date string is valid
    // you may add more conditions to make the checking more stringent
    if(!PDClass[PDlengthFull] || PDClass[PDlengthFull] > 18)  // length is 0 or string is too long
        return FALSE;
    else if(!PDClass[PDnComma] || !PDClass[PDnSpace])  // no space, no comma found
        return FALSE;
    else if(PDClass[PDnComma] < PDClass[PDnSpace])
        return FALSE;
    else if(PDClass[PDlengthMonth] < 3 || PDClass[PDlengthMonth] > 9)
        return FALSE;
    else if(PDClass[PDlengthDay]< 1 || PDClass[PDlengthDay] > 2)
        return FALSE;
    else if(PDClass[PDlengthYear] < 1 || PDClass[PDlengthYear] > 4)
        return FALSE;
    else if(str_GetByte(PDClass[PDnComma] + 1) != ' ')
        return FALSE;
    // add your conditions here

    endif

    // assign byte-aligned pointers for string operations
    PDClass[PDptrSsMonth] := str_Ptr(&PDClass[PDssMonth]);
    PDClass[PDptrSsDay]   := str_Ptr(&PDClass[PDssDay]);
    PDClass[PDptrSsYear]  := str_Ptr(&PDClass[PDssYear]);

    // copy data from date string to substring
    str_CopyN(PDClass[PDptrSsMonth], PDClass[PDptr], PDClass[PDlengthMonth]); // copy month substring
    str_CopyN(PDClass[PDptrSsDay ] , PDClass[PDnSpace] + 1, PDClass[PDlengthDay]);   // copy day substring
    str_CopyN(PDClass[PDptrSsYear] , PDClass[PDnComma] + 2, PDClass[PDlengthYear]);  // copy year substring

    //test day if single- or double-digit; if single digit, remove comma
    if((PDClass[PDssDay] >> 8) == ',')   PDClass[PDssDay] &= 0x00FF;

    // Convert day ASCII charaters  to equivalent integer
    if(!str_GetW(&PDClass[PDptrSsDay], PDClass[PDptrGDay]))
        return FALSE;
    endif

    // Convert year ASCII charaters  to equivalent integer
    if(!str_GetW(&PDClass[PDptrSsYear], PDClass[PDptrGYear]))
        return FALSE;
    endif

    // Compare month substring to stored correct month strings
    for(PDClass[PDcounter] := 0; PDClass[PDcounter] < 12 && !PDClass[PDflag]; PDClass[PDcounter]++)
        PDClass[PDptr] := str_Ptr(monthNameLong[PDClass[PDcounter]]);
        if(str_FindI(&PDClass[PDptr],&PDClass[PDssMonth]))
            *PDClass[PDptrGMonth] := PDClass[PDcounter] + 1;
            PDClass[PDflag] := TRUE;
        endif
    next

    if(!PDClass[PDflag])
        return FALSE;
    endif

    return TRUE;
endfunc
